<?php

require_once ABSPATH . 'wp-admin/includes/upgrade.php';


/**
 * Check if a table exists in the WordPress database
 *
 * @param string $table_name The name of the table to check.
 * @return bool True if the table exists, false otherwise.
 */
function table_exists($table_name)
{
    global $wpdb;
    $table_name = sanitize_text_field($table_name);

    // Get a list of all tables in the WordPress database
    $tables = $wpdb->get_col('SHOW TABLES', 0);

    // Search for the table in the list of tables
    return in_array($wpdb->prefix . $table_name, $tables);
}
