function sendRequest(videoId, userPhone) {
  const inputValue = document.getElementById('vidprotect-phone-input')?.value;
  const content = document.getElementById('content');

  const url =
      window.location.origin +
      window.location.pathname +
      '?api-type=vidprotect&id=' +
      videoId +
      (userPhone === '' ? userPhone : '&phone=' + inputValue);

  const http = new XMLHttpRequest();
  http.open('GET', url);
  http.onreadystatechange = function() {
    if (http.readyState === 4 && http.status === 200) {
      try {
        const data = JSON.parse(http.responseText);

        if (data?.url) {
          content.innerHTML = `
                            <iframe 
                                src="${data?.url}"
                                class="vidprotect-example"
                                allow="encrypted-media *; fullscreen"
                                > </iframe>`;
        } else {
          content.innerHTML = `<p class='tel-label'>متاسفانه ویدیو یافت نشد</p>`;
        }
      } catch (error) {
        content.innerHTML = `<p class='tel-label'>خطایی رخ داده لطفا با مدیریت سایت تماس بگیرید</p>`;
      }
    }
  };
  http.send();
}

window.addEventListener(
    'hashchange',
    function(_) {
      const popup = document.getElementById('vidprotect-popup');

      if (window.location.hash === '#close-vidprotect') {
        popup.style.opacity = 0;
        popup.style.zIndex = -100;
        popup.remove();
      } else if (window.location.hash.includes('#vidprotect=')) {
        const videoId = window.location.hash.replace('#vidprotect=', '');
        const newNode = document.createElement('span');

        newNode.innerHTML =
            `<div id="vidprotect-popup" style="opacity: 0; z-index: -100;">
                      <div class="popup">
                        <a class="close" href="#close-vidprotect">&times;</a>
                        <div class="content" id="content">
                           <p class="tel-label">
                                    برای ارسال خودکار شماره موبایل کاربر و درج آن بر روی صفحه از افزونه‌های پشتیبانی شده استفاده نمایید 
                                     </br> 
                                     و یا شماره موبایل خود را بصورت دستی در کادر زیر وارد نمایید
                                     </p> 
                                     <input
                                        type="tel"
                                        id="vidprotect-phone-input" 
                                        maxlength="11"
                                        minlength="11"
                                        placeholder="09XXXXXXXXX"
                                        oninput="handleChangeInput(this.value)"/>
                                     <button
                                        class="vidprotect-button"
                                        id="vidprotect-button-submit"
                                        disabled 
                                        type="button"
                                        onclick="sendRequest('${videoId}')">مشاهده</button>
                        </div>
                      </div>
                 </div>
                `;

        document.body.appendChild(newNode);
        const popup = document.getElementById('vidprotect-popup');
        popup.style.transition = 'opacity 500ms';
        popup.style.opacity = 1;
        popup.style.zIndex = 100000;
        window.location.hash = '';
      }
    },
    false,
);

function handleChangeInput(str) {
  const btn = document.getElementById('vidprotect-button-submit');

  btn.disabled = str.length === 0;

  btn.style.backgroundColor = '#666666';

  const persianNumbers = ['۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹', '۰'];
  const arabicNumbers = ['١', '٢', '٣', '٤', '٥', '٦', '٧', '٨', '٩', '٠'];
  const englishNumbers = ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'];

  if (typeof str === 'undefined') {
    str = '';
  }

  document.getElementById('vidprotect-phone-input').value = str.toString().
      split('').
      map(
          (c) =>
              englishNumbers[persianNumbers.indexOf(c)] ||
              englishNumbers[arabicNumbers.indexOf(c)] ||
              c,
      ).
      join('');
}
