<?php


function get_supported_auth_plugins()
{
    return [
        [
            "fn_name" => "get_none",
            "metaKey" => "",
            "title" => "غیر فعال",
            "key" => "none",
        ],
        [
            "fn_name" => "get_meta_key",
            "metaKey" => "",
            "title" => "سفارشی",
            "key" => "custom",
        ],
        [
            "fn_name" => "get_test",
            "metaKey" => "",
            "title" => "آزمایشی",
            "key" => "test",
        ],
        [
            "fn_name" => "get_digits_mobile",
            "metaKey" => "digits_phone_no",
            "title" => "دیجیتس",
            "key" => "digits",
        ]
    ];
}

function find_plugin($type)
{
    $valid_auth_plugins = get_supported_auth_plugins();

    $found = [];

    foreach ($valid_auth_plugins as $plugin) {
        if ($type == $plugin['key']) {
            $found = $plugin;
            break;
        }
    }

    if (empty($found)) {
        $found = array_filter($valid_auth_plugins, function ($plugin) {
            return $plugin['key'] == "none";
        })[0];
    }

    if ($found['key'] == "custom") {
        $options = get_option('vidprotect_plugin_options');
        $found['metaKey'] = $options['auth_meta_key'];
    }

    return $found;
}

function get_auth_plugin_object()
{
    $options = get_option('vidprotect_plugin_options');

    return find_plugin($options['auth_plugin']);
}

function have_meta_key()
{
    $plugin = get_auth_plugin_object();

    if (empty($plugin)) {
        return false;
    }

    return $plugin['fn_name']($plugin['metaKey']);
}

function get_none()
{
    return "";
}

function get_test()
{
    return "";
}

function get_digits_mobile($type)
{
    if (!table_exists('digits_mobile_otp')) {
        return "";
    }

    return get_meta_key($type);
}

function get_meta_key($type)
{
    return get_user_meta(get_current_user_id(), $type, true);
}

function verify_mobile($phone)
{
    if (empty($phone)) {
        return "";
    }

    if (is_object($phone) || is_array($phone)) {
        return "";
    }

    if (substr($phone, 0, 2) == '09') {
        return $phone;
    }

    if (substr($phone, 0, 2) == '98') {
        return '0' . substr($phone, 2);
    }

    if (substr($phone, 0, 3) == '+98') {
        return '0' . substr($phone, 3);
    }

    if (substr($phone, 0, 1) == '9') {
        return '0' . $phone;
    }

    return $phone;
}

function isIranianMobile($str)
{
    return preg_match('/^09[0-9]{9}$/', $str);
}