<?php

function get_files_from_api($page = 1, $order_by_date = "desc")
{
    $options = get_option('vidprotect_plugin_options');
    $opts = [
        "http" => [
            "ignore_errors" => true,
            "method" => "GET",
            "header" => "api_key: " . $options["api_key"] . "\r\n" .
                "secret_key: " . $options["secret_key"] . "\r\n"
        ]
    ];
    $context = stream_context_create($opts);
    $request = file_get_contents(
        BACK_URL . "all?currentPage=$page&sortBy=createdAt:$order_by_date",
        false,
        $context
    );

    return @json_decode($request);
}

function verify_keys()
{
    $options = get_option('vidprotect_plugin_options');

    if (empty($options['api_key']) || empty($options['secret_key'])) {
        return ["ok" => true, "message" => ""];
    }

    $res = get_files_from_api();

    if (!isset($res->code)) {
        return ["ok" => true, "message" => ""];
    }

    return ["ok" => false, "message" => $res->message];
}

function have_file()
{
    $options = get_option('vidprotect_plugin_options');

    if (empty($options['api_key']) || empty($options['secret_key'])) {
        return false;
    }

    $files = get_files_from_api();

    if (!isset($files->results)) {
        return false;
    }

    return count($files->results) != 0;
}